print("load questdata.lua ...")
--require "Pickle"
loadstring(GetFileString("lua/Pickle.lua"))()
-- 任务存档

-- 加载任务存档
function loadQuestData()
	local s = CCUserDefault:sharedUserDefault():getStringForKey("Quest_Data")
	if s == "" then
		return {}
	end
	return unpickle(s)
end

function saveQuestData()
	if QuestDataDict ~= nil then
		local s = pickle(QuestDataDict)
		CCUserDefault:sharedUserDefault():setStringForKey("Quest_Data", s)
	end
	
	return 0
end
print("loadQuestData success");

QuestData = {		-- 每个任务存档的具体内容
	flag = 0,		-- 任务标志
	year = 0,		-- 年份
	month = 0,		-- 月份
	day = 0,		-- 日期
	accepttime = 0,	-- 接受任务的时间
	trigger =		-- 开启条件完成数量
	{
		{triggerCount = 0,}
	},
	target =		-- 完成条件的完成数量
	{
		{triggerCount = 0,}
	},
}

QuestDataDict = loadQuestData()	-- 任务存档

for k, v in pairs(QuestDataDict) do
	CCLuaLog(string.format("%d: flag = %d", k, v.flag))
end

function createQuestData(ms)
	if QuestDataDict[ms.id] == nil then
		QuestDataDict[ms.id] = {
			flag = 0,
			year = 0,		-- 年份
			month = 0,		-- 月份
			day = 0,		-- 日期
			accepttime = 0,	-- 接受任务的时间
			count = ms.maxcount,	-- 任务的可接受次数
			trigger ={},
			target = {},
		}
	end
end

print("createQuestData success")

function updateQuestTime(ms)
	QuestDataDict[ms.id].year = GetYear()
	QuestDataDict[ms.id].month = GetMonth()
	QuestDataDict[ms.id].day = GetDay()
	if ms.accepttime ~= nil then
		QuestDataDict[ms.id].accepttime = ms.accepttime
	end
end

print("updateQuestTime success")

-- 刷新日常任务
function refreshDayQuest(ms)
	if QuestDataDict[ms.id] == nil then
		return
	end
	
	local t = QuestDataDict[ms.id]
	t.accepttime = 0
	if t.year ~= GetYear() or t.month ~= GetMonth() or t.day ~= GetDay() then
		if t.flag == 3 or t.flag == 4 then
			t.flag = 0
			updateQuestEvent(ms)
			t.count = ms.maxcount
		end
	end
end

print("refreshDayQuest success")

function isCanOpenQuestAgain(ms)
	if QuestDataDict[ms.id] == nil then
		return false
	end
	
	local t = QuestDataDict[ms.id]
	t.count = t.count - 1
	if t.count > 0 then
		-- 重置任务的条件
		for k, v in pairs(ms.trigger) do
			v.triggerCount = 0
		end
		
		for k, v in pairs(ms.target) do
			v.triggerCount = 0
		end	
		updateQuestEvent(ms)
		return true
	end
	return false
end

print("isCanOpenQuestAgain success")

function getQuestFlag(ms)
	local ret = 0
	if ms ~= nil and QuestDataDict[ms.id] ~= nil then
		ret = QuestDataDict[ms.id].flag
		local qd = QuestDataDict[ms.id]
		
		ms.accepttime = qd.accepttime	-- 添加接受时间
		
		for k, v in pairs(ms.trigger) do
			if qd.trigger[k] ~= nil then
				v.triggerCount = qd.trigger[k].triggerCount
			end
			
		end
		
		for k, v in pairs(ms.target) do
			if qd.target[k] ~= nil then
				v.triggerCount = qd.target[k].triggerCount
			end
		end
	end
	
	return ret
end

print("getQuestFlag success")

-- 设置任务的标志，不保存
function setQuestFlag(flag, ms)
	if QuestDataDict[ms.id] ~= nil and QuestDataDict[ms.id].flag ~= flag then
		QuestDataDict[ms.id].flag = flag
	end
end

print("setQuestFlag success")

function setQuestToken(ms, token)
	if QuestDataDict[ms.id] == nil then
		createQuestData(ms)
	end
	
	if QuestDataDict[ms.id] ~= nil then
		QuestDataDict[ms.id].token = token
		--saveQuestData()
	end
end

print("setQuestToken success")

function getQuestToken(ms, m)
	if QuestDataDict[ms.id] ~= nil and QuestDataDict[ms.id].token then
		print(string.format("%d token %s", ms.id, QuestDataDict[ms.id].token));
		SetMissionToken(m, QuestDataDict[ms.id].token)
	end
end

-- 更新任务的标志
function changeQuestFlag(flag, ms)
	createQuestData(ms)
	if QuestDataDict[ms.id] ~= nil and QuestDataDict[ms.id].flag ~= flag then
		QuestDataDict[ms.id].flag = flag
		updateQuestTime(ms)
		--saveQuestData()
	end
end

print("changeQuestFlag success")

-- 更新任务的条件
function updateQuestEvent(ms)
	createQuestData(ms)
	local qd = QuestDataDict[ms.id]
	for k, v in pairs(ms.trigger) do
		if qd.trigger[k] == nil then
			qd.trigger[k] = {}
		end
		qd.trigger[k].triggerCount = v.triggerCount
	end
	
	for k, v in pairs(ms.target) do
		if qd.target[k] == nil then
			qd.target[k] = {}
		end
		qd.target[k].triggerCount = v.triggerCount
	end
	
	updateQuestTime(ms)
	
	--saveQuestData()
end

print("load questdata.lua success")