print("load smallplanet.lua ...")
loadstring(GetFileString("lua/questdata.lua"))()
CCLuaLog("load smallplanet.lua ...2")
-- 执行文件内容，返回执行结果
function execfile(filename)
	print("load quest " .. filename)
	--print(GetFileString(filename))
	return loadstring("return " .. GetFileString(filename))()
end

-- 解释文字配置文件
function execTextIni(filename)
	local t = {}
	local s = GetFileString(filename)
	for k,v in string.gfind(s, "([^%s=]+)%s?=%s?([^\n]+)") do
		t[k] = v
	end
	
	return t
end

Lang = {}
if kLanguageChinese == CCApplication.getCurrentLanguage() then
	Lang = execTextIni("lua/lang/quest.txt")
else
	Lang = execTextIni("lua/lang/quest_EN.txt")
end

Mission = {}			-- 所有任务的列表
OpenMission = {}		-- 等待开启的任务列表
WaitParentMission = {}	-- 等待前置任务完成的任务列表
AcceptableMission = {}	-- 可接受的任务列表
AcceptedMission = {}	-- 已接受的任务列表
CompleteMission = {}	-- 已经完成但还没有提交的任务列表
SubmitedMission = {}	-- 已经提交了的任务
FailMission = {}		-- 失败的任务

OpenEventDict = {}		-- 开启触发事件字典，key 任务的触发条件	value 任务
ActionEventDict = {}	-- 执行触发事件字典

function executeMission(n)
	local index = tonumber(n)
	tb = {"adsf", "dsf"}
	for k, v in pairs(tb) do
		--print(v)
		--table.remove(tb, k)
	end
	for k, v in pairs(tb) do
		--print(v)
	end
	
	if Mission[index] ~= nil then
		--print(index)
		for k, v in pairs(Mission[index]) do
			--print(v)
		end
	end
end

-- 添加任务触发
function addTriggerEvent(eventDict, triList, ms)
	for k, v in pairs(triList) do
		if eventDict[v.type] == nil then 
			eventDict[v.type] = {}
		end
		--print(string.format("add trigger event %d", v.type))
		table.insert(eventDict[v.type], ms)
	end
end

-- 删除任务触发
function removeTriggerEvent(eventDict, triList, ms)
	for k, v in pairs(triList) do
		if eventDict[v.type] == nil then 
			eventDict[v.type] = {}
		end
		
		for k1, v1 in pairs(eventDict[v.type]) do
			if v1 == ms then
				table.remove(eventDict[v.type], k1)
			end
		end
	end
end

-- 删除任务对应类型的事件触发
function removeTriggerEventByType(eventDict, type, ms)
	if eventDict[type] ~= nil then
		for k1, v1 in pairs(eventDict[type]) do
			if v1 == ms then
				table.remove(eventDict[type], k1)
			end
		end
	end
end

-- 检查任务的开启条件是否全部达成
function checkQuestCnt(cnt)
	local ret = true
	for k, v in pairs(cnt) do
		-- 如果是玩家属性条件，则重新读取条件
		if v.type == 0 then
			v.triggerCount = GetPlayerPro(v.id)
		end
		if v.triggerCount == nil then
			--print("TriggerCount is nil")
			return false
		end
		
		--print("TriggerCount is", v.triggerCount)
		--print("NeedCount is", v.count)
		
		if v.triggerCount < v.count then ret = false end
	end
	--print("check quest cnt result", ret)
	return ret
end

-- 创建新任务到c++中
function newMission(ms)
	local tt = 0
	if ms.accepttime ~= nil and ms.accepttime ~= 0 then
		tt = GetSec() - ms.accepttime
		if tt < 0 then
			tt = 31536000
		end
	end
	local m = CreateMission(ms.id, ms.type, ms.name, ms.content, ms.crystal, ms.timelimit, tt, ms.hasCrystal)
	getQuestToken(ms, m)
	
	-- 添加奖励内容
	local awards = ms.awards
	if awards ~= nil then
		for k,v in pairs(awards) do
			SetMissionAward(m, v.type, v.id, v.count)
		end
	end
end

-- 加载任务
function loadMission(filename)
	print("load file "..filename)
	local ms = execfile(filename)
	
	if Mission[ms.id] ~= nil then return end
	Mission[ms.id] = ms
	print(string.format("mission'id %d", ms.id))
	
	if ms.hasCrystal ~= nil and ms.hasCrystal == true then
		CCLuaLog(string.format("Crystal mission: %d", ms.id))
	end
	
	-- 日常任务
	if ms.type == 2  then
		refreshDayQuest(ms)
	end
	
	local flag = getQuestFlag(ms)
	
	if flag == 0 or flag == nil then	-- 还没接受的任务
		if not openQuest(ms.id) then
			-- 尝试开启任务不成功
			print(string.format("add mission %d", ms.id))
			OpenMission[ms.id] = ms
			addTriggerEvent(OpenEventDict, ms.trigger, ms)
		end
	elseif flag == 1 then	-- 已接但还未完成的任务
		--CreateMission(ms.id, ms.name, ms.content, ms.crystal, ms.timelimit)
		newMission(ms)
		SetMissionAccepted(ms.id)
		--acceptQuest(ms.id)
	elseif flag == 2 then	-- 已完成但还未提交的任务
		--CreateMission(ms.id, ms.name, ms.content, ms.crystal, ms.timelimit)
		newMission(ms)
		SetMissionAccepted(ms.id)
		completeQuest(ms.id)
	elseif flag == 3 then	-- 已提交的任务
		SubmitedMission[ms.id] = ms
	elseif flag == 4 then	-- 失败的任务
		FailMission[ms.id] = ms
	end
end

print(loadMission)

function setMsToken(msId, token)
	local index = tonumber(msId)
	print(Mission[index])
	if Mission[index] ~= nil then
		setQuestToken(Mission[index], token)
	end
end

-- 开启任务响应函数
function openQuest(n)
	local index = tonumber(n)
	print("try to open mission", index)
	--if OpenMission[index] ~= nil then 
	--	print("mission has exist in OpenMission[]")
	--	return false 
	--end
	local ms = Mission[index]
	if ms ~= nil then
		if getQuestFlag(ms) == 0 then
			if checkQuestCnt(ms.trigger) then	-- 达成所有开启条件
				-- 检查前置任务
				removeTriggerEvent(OpenEventDict, ms.trigger, ms)
				if ms.parentid ~= 0 and getQuestFlag(Mission[ms.parentid]) ~= 3 then
					OpenMission[index] = nil	
					WaitParentMission[ms.id] = ms
					return false
				end
				AcceptableMission[index] = ms
				OpenMission[index] = nil
				--CreateMission(index, ms.name, ms.content, ms.crystal, ms.timelimit)
				newMission(ms)
				
				local f = loadstring(string.format("return quest_open_%d", ms.id))()
				if f ~= nil then
					f()
				end
				
				print(string.format("open mission %d", ms.id))
				return true
			end
		end
	end
	return false
end

-- 接受任务响应函数
function acceptQuest(n)
	local index = tonumber(n)
	CCLuaLog(string.format("Accept quest: %d", n))
	local ms = Mission[index]
	if ms ~= nil then
		-- 接受任务，启动任务过程监听
		if ms.accepttime == nil or ms.accepttime == 0 then
			ms.accepttime = GetSec()		-- 接受任务的时间
		end
		changeQuestFlag(1, ms)
		AcceptableMission[index] = nil
		AcceptedMission[index] = Mission[index]
		addTriggerEvent(ActionEventDict, ms.target, ms)
		
		local f = loadstring(string.format("return quest_accept_%d", ms.id))()
		if f ~= nil then
			f()
		end
	end
end

-- 任务完成条件达成响应
function completeQuest(n)
	local index = tonumber(n)
	CCLuaLog(string.format("Complete quest: %d", n))
	local ms = Mission[index]
	if ms ~= nil then
		if checkQuestCnt(ms.target) then
			changeQuestFlag(2, ms)
			removeTriggerEvent(ActionEventDict, ms.target, ms)
			AcceptedMission[ms.id] = nil
			CompleteMission[ms.id] = ms
			SetMissionComplete(ms.id)
			
			local f = loadstring(string.format("return quest_complete_%d", ms.id))()
			if f ~= nil then
				f()
			end
		end
	end
end

-- 使用水晶完成任务响应
function completeQuestByCrystal(n)
	local index = tonumber(n)
	CCLuaLog(string.format("Complete quest by crystal: %d", n))
	local ms = Mission[index]
	if ms ~= nil then
		if ms.target ~= nil then
			for k, v in pairs(ms.target) do
				v.triggerCount = v.count
			end
			updateQuestEvent(ms)
		end
		completeQuest(n)
	end
end

-- 放弃任务响应函数
function abnegateQuest(n)
	local index = tonumber(n)
	CCLuaLog(string.format("Abnegate quest: %d", n))
	local ms = Mission[index]
	if ms ~= nil then
		AcceptedMission[index] = nil
		removeTriggerEvent(ActionEventDict, ms.target, ms)
		
		local f = loadstring(string.format("return quest_abnegate_%d", ms.id))()
		if f ~= nil then
			f()
		end
	end
end

-- 任务失败
function failQuest(n)
	local index = tonumber(n)
	CCLuaLog(string.format("Fail quest: %d", n))
	local ms = Mission[index]
	if ms ~= nil then
		AcceptedMission[index] = nil
		changeQuestFlag(4, ms)
		removeTriggerEvent(ActionEventDict, ms.target, ms)
		SetMissionFail(ms.id)
		
		local f = loadstring(string.format("return quest_fail_%d", ms.id))()
		if f ~= nil then
			f()
		end
	end
end

-- 提交任务响应函数
function submitQuest(n)
	local index = tonumber(n)
	CCLuaLog(string.format("Submit quest %d", n))
	local ms = Mission[index]
	if ms ~= nil then
		if ms.type == 2 and isCanOpenQuestAgain(ms) then
			-- 如果是日常类型，则查看是否能够再次启动
			changeQuestFlag(0, ms)
			if not openQuest(ms.id) then
				-- 尝试开启任务不成功
				print("open again fail")
				OpenMission[ms.id] = ms
				addTriggerEvent(OpenEventDict, ms.trigger, ms)
			end
		else
			changeQuestFlag(3, ms)
			CompleteMission[index] = nil
			SubmitedMission[index] = ms
		end
		-- 给予奖励
		setAward(ms)
		
		-- 提交任务之后，尝试开启前置任务是本任务的任务
		for k, v in pairs(WaitParentMission) do
			if v.parentid == index then
				openQuest(v.id)
			end
		end
		
		local f = loadstring(string.format("return quest_submit_%d", ms.id))()
		if f ~= nil then
			f()
		end
	end
end

-- 给予任务奖励
function setAward(ms)
	if ms.awards ~= nil then
		for k, v in pairs(ms.awards) do
			if v.type == 0 then		-- 添加玩家属性
				AddPlayerPro(v.id, v.count)
			end
		end
	end
end

function showQuestTip(n)
	local index = tonumber(n)
	CCLuaLog(string.format("Show quest tip %d", n))
	local ms = Mission[index]
	if ms ~= nil and 0 == ms.type then
		for k, v in pairs(ms.target) do
			SetMissionShowTip(ms.id, v.type, v.id)
		end
	end
end

-- 添加触发事件的开启数量
function addEvent(eventType, cnt, ms)
	local ret = true		-- 开启条件的结果
	local hasChange = false	-- 条件结果是否有改变
	if cnt == nil then ret = false end
	for k, v in pairs(cnt) do
		if eventType == v.type then
		
			local isTrue = false	-- 是否要增加数量
			if eventType == 0 then
				v.triggerCount = GetPlayerPro(v.id)
			elseif eventType == 1 or eventType == 2 then	-- 建筑
				print(string.format("%d", GetBuildingId()))
				if GetBuildingId() == v.id or v.id == 0 then 
					isTrue = true
				end
			elseif eventType == 3 or eventType == 4 then	-- 单位
				print(string.format("Unit id %d", GetUnitId()))
				if GetUnitId() == v.id or v.id == 0 then 
					isTrue = true 
				end
			elseif eventType == 5 or eventType == 6 or eventType == 7 then	-- 物品
				if GetEventId() == v.id or v.id == 0 then 
					isTrue = true 
				end
			elseif eventType == 10 then		-- 信徒进驻建筑
				isTrue = true
			elseif eventType == 20 then		-- 清理垃圾
				isTrue = true
				--if GetEventId() == v.id then
				--	isTrue = true
				--end
			elseif eventType == 30 then		-- 好友响应
				isTrue = true
			elseif eventType == 35 then		-- 好友数量
				isTrue = true
			elseif eventType == 40 then		-- 特殊事件
				if v.id == 1 or v.id == 0 or GetBuildingId() == v.id then
					if v.unitid == nil or v.unitid == 0 or v.unitid == GetBuildingId() then
						isTrue = true
					end
				end
			elseif eventType == 50 then		-- 砍伐树木
				if v.id == 0 or GetEventId() == v.id then
					isTrue = true
				end
			elseif eventType == 51 then		-- 收割庄稼
				if GetEventId() == v.id then
					isTrue = true
				end
			else							-- 默认的匹配模式
				if GetEventId() == v.id then
					isTrue = true
				end
			end
			
			if isTrue then 
				hasChange = true
				if v.triggerCount == nil then
					v.triggerCount = 1
				else
					v.triggerCount = v.triggerCount + 1
				end
			end
		else
			if v.type == 0 then
				v.triggerCount = GetPlayerPro(v.id)
			end
		end
		
		-- 判断开启结果
		if v.triggerCount == nil or v.triggerCount < v.count then 
			ret = false 
		end
	end
	
	if hasChange then updateQuestEvent(ms) end
	
	return ret
end


-- 触发事件响应
function TriggerEvent(et)
	-- 检查开启列表
	eventType = tonumber(et)
	--CCLuaLog(string.format("trigger event %d", eventType))
	if OpenEventDict[eventType] ~= nil then
		for k1, v1 in pairs(OpenEventDict[eventType]) do
			print("trigger open event ", eventType)
			-- 增加被触发的次数
			if addEvent(eventType, v1.trigger, v1) then
				-- 满足这个触发条件，删除这个事件
				if eventType ~= 0 then
					removeTriggerEventByType(OpenEventDict, eventType, v1)
				end
				openQuest(v1.id)	-- 尝试开启任务
			end
		end
	end
	
	-- 检查任务进行列表
	if ActionEventDict[eventType] ~= nil then
		for k1, v1 in pairs(ActionEventDict[eventType]) do
			print("trigger action event")
			-- 增加被触发的次数
			if addEvent(eventType, v1.target, v1) then
				-- 满足开启条件，删除触发
				if eventType ~= 0 then
					removeTriggerEventByType(ActionEventDict, eventType, v1)
				end
				completeQuest(v1.id)	-- 尝试完成任务
			end
		end
	end
end

print("load smallplanet.lua success");